"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAccount = exports.deploy = exports.getAppWriteClient = exports.getKardiaContract = void 0;
const ethers = __importStar(require("ethers"));
const node_appwrite_1 = require("node-appwrite");
const AccountProvider_json_1 = __importDefault(require("../build/contracts/AccountProvider.json"));
const typechain_1 = require("./typechain");
const APPWRITE_ENDPOINT = process.env.APPWRITE_ENDPOINT;
const APPWRITE_FUNCTION_PROJECT_ID = process.env
    .APPWRITE_FUNCTION_PROJECT_ID;
const APPWRITE_API_KEY = process.env.APPWRITE_API_KEY;
const getKardiaContract = (kardiaClient) => {
    const contractInstance = kardiaClient.contract;
    contractInstance.updateAbi(typechain_1.AccountProvider__factory.abi);
    contractInstance.updateByteCode(AccountProvider_json_1.default.bytecode);
    return contractInstance;
};
exports.getKardiaContract = getKardiaContract;
const getAppWriteClient = () => {
    const client = new node_appwrite_1.Client();
    client
        .setEndpoint(APPWRITE_ENDPOINT)
        .setProject(APPWRITE_FUNCTION_PROJECT_ID)
        .setKey(APPWRITE_API_KEY);
    return client;
};
exports.getAppWriteClient = getAppWriteClient;
const getProvider = () => {
    const provider = new ethers.providers.JsonRpcProvider(process.env.RPC_ENDPOINT);
    return provider;
};
const deploy = () => {
    return Promise.resolve("");
};
exports.deploy = deploy;
async function createAccount(contractAddress, { email }, provider) {
    const selectProvider = provider || getProvider();
    const accountProvider = typechain_1.AccountProvider__factory.connect(contractAddress, selectProvider);
    const slug = ethers.utils.formatBytes32String(email);
    const tx = await accountProvider.createAccount(slug);
    const response = await tx.wait();
    const events = response.events;
    console.log(JSON.stringify(events, null, 2));
    // if (events[1].event.name == "AccountRegistered") {
    //   const { accountId, slug, accountAddress } = events[1].event as any;
    //   console.log({ accountId, slug, accountAddress });
    //   const account = new Users(client).updatePrefs(payload.$id, {
    //     smcAddress: accountAddress,
    //   });
    //   console.log(`Updated prefs: ${JSON.stringify(account)}`);
    // }
}
exports.createAccount = createAccount;
