import { Signer, ContractFactory, Overrides } from "ethers";
import { Provider, TransactionRequest } from "@ethersproject/providers";
import type { AccoutProviderStorage, AccoutProviderStorageInterface } from "../AccoutProviderStorage";
export declare class AccoutProviderStorage__factory extends ContractFactory {
    constructor(signer?: Signer);
    deploy(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<AccoutProviderStorage>;
    getDeployTransaction(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): TransactionRequest;
    attach(address: string): AccoutProviderStorage;
    connect(signer: Signer): AccoutProviderStorage__factory;
    static readonly bytecode = "0x6080604052348015600f57600080fd5b50603f80601d6000396000f3fe6080604052600080fdfea2646970667358221220361f0b3c99389baad6cd9f90676c9ff060ae6efc0b7c8d12d2f0cc3ef8d257c864736f6c63430008040033";
    static readonly abi: {
        anonymous: boolean;
        inputs: {
            indexed: boolean;
            internalType: string;
            name: string;
            type: string;
        }[];
        name: string;
        type: string;
    }[];
    static createInterface(): AccoutProviderStorageInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): AccoutProviderStorage;
}
