/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface AccountProviderInterface extends ethers.utils.Interface {
  functions: {
    "accountById(uint256)": FunctionFragment;
    "accountBySlug(bytes32)": FunctionFragment;
    "createAccount(bytes32)": FunctionFragment;
    "deleteAccount(bytes32)": FunctionFragment;
    "isAccount(address)": FunctionFragment;
    "totalUsers()": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "accountById",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "accountBySlug",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "createAccount",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "deleteAccount",
    values: [BytesLike]
  ): string;
  encodeFunctionData(functionFragment: "isAccount", values: [string]): string;
  encodeFunctionData(
    functionFragment: "totalUsers",
    values?: undefined
  ): string;

  decodeFunctionResult(
    functionFragment: "accountById",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "accountBySlug",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "createAccount",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "deleteAccount",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "isAccount", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "totalUsers", data: BytesLike): Result;

  events: {
    "AccountCreated(uint256,bytes32,address)": EventFragment;
    "AccountDeleted(uint256,bytes32,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AccountCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "AccountDeleted"): EventFragment;
}

export type AccountCreatedEvent = TypedEvent<
  [BigNumber, string, string] & {
    accountId: BigNumber;
    slug: string;
    accountAddress: string;
  }
>;

export type AccountDeletedEvent = TypedEvent<
  [BigNumber, string, string] & {
    accountId: BigNumber;
    slug: string;
    accountAddress: string;
  }
>;

export class AccountProvider extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: AccountProviderInterface;

  functions: {
    accountById(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[string]>;

    accountBySlug(
      slug_: BytesLike,
      overrides?: CallOverrides
    ): Promise<[string]>;

    createAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    deleteAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    isAccount(
      accountContract_: string,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    totalUsers(overrides?: CallOverrides): Promise<[BigNumber]>;
  };

  accountById(
    accountId_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<string>;

  accountBySlug(slug_: BytesLike, overrides?: CallOverrides): Promise<string>;

  createAccount(
    slug_: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  deleteAccount(
    slug_: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  isAccount(
    accountContract_: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  totalUsers(overrides?: CallOverrides): Promise<BigNumber>;

  callStatic: {
    accountById(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<string>;

    accountBySlug(slug_: BytesLike, overrides?: CallOverrides): Promise<string>;

    createAccount(slug_: BytesLike, overrides?: CallOverrides): Promise<void>;

    deleteAccount(slug_: BytesLike, overrides?: CallOverrides): Promise<void>;

    isAccount(
      accountContract_: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    totalUsers(overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {
    "AccountCreated(uint256,bytes32,address)"(
      accountId?: null,
      slug?: null,
      accountAddress?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { accountId: BigNumber; slug: string; accountAddress: string }
    >;

    AccountCreated(
      accountId?: null,
      slug?: null,
      accountAddress?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { accountId: BigNumber; slug: string; accountAddress: string }
    >;

    "AccountDeleted(uint256,bytes32,address)"(
      accountId?: null,
      slug?: null,
      accountAddress?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { accountId: BigNumber; slug: string; accountAddress: string }
    >;

    AccountDeleted(
      accountId?: null,
      slug?: null,
      accountAddress?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { accountId: BigNumber; slug: string; accountAddress: string }
    >;
  };

  estimateGas: {
    accountById(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    accountBySlug(
      slug_: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    createAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    deleteAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    isAccount(
      accountContract_: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    totalUsers(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    accountById(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    accountBySlug(
      slug_: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    createAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    deleteAccount(
      slug_: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    isAccount(
      accountContract_: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    totalUsers(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
